#!/usr/local/bin/perl  -- -*- C -*-

# Load the Net::FTP package
use Net::FTP;

# I will explain the use of this module later
use File::Listing qw(parse_dir);

sub RemoteFTP {
#
# Upload des fichiers sur une machine
#
# Arguments: hote, repertoire distant, login, passwd, chemin de destination
#
$RemoteHost   = 'localhost';
#$RemotePath   = '~$user/public_html/$direc';
$RemotePath   = '/public_html';
$RemoteName   = 'toto';
$RemotePasswd = 'toto';
$LocalPath    = "/home/www/html/darche/c/upld";
local($RemoteHost,$RemotePath,$RemoteName,$RemotePasswd,$LocalPath)=@_;
local($log)="";

# Create a new NET::FTP object

# NOTE: I have also changed the timeout
# value to be 60 seconds

$ftp = Net::FTP->new($RemoteHost, Timeout => 60) or
	 return ($log,"Cannot contact $RemoteHost: $!");

# We shall login to the ftp server as anonymous
# Specifying a login id stops any netrc lookup

$ftp->login($RemoteName,$RemotePasswd) or
    return ($log,"Cannot login ($RemoteHost):" . $ftp->message);

# Change the working directory
$ftp->cwd($RemotePath) or
    return ($log,"Cannot change directory ($RemoteHost):" . $ftp->message);

# Retrieve a recursive directory listing
@ls = $ftp->ls('-lR');

# We probably do want binary, although some files
# may be ASCII :-)

$ftp->binary();

# cre le chemin si ncessaire
if (!(-e $LocalPath)) {
	mkdir $LocalPath,0755;
	print "$LocalPath cre<BR>\n";
}

chdir $LocalPath;

foreach $file (parse_dir(\@ls)) {
	my($name, $type, $size, $mtime, $mode) = @$file;

	# We only want to process plain files,
	# we shall ignore symbolic links
	next unless($type eq 'f');

	# Check age of file against $age
	# $mtime is a unix date value, that is
	#   seconds since 1 Jan 1970
	# $^T is the time this script started
	#   as a unix date value
	print "Retrieving $name($size)<BR>\n";

	# recherche des sous repertoires et cration
	#
	($dirname)=($name=~/(.*)\/[^\/]*/);

	@tab=split(/\//,$dirname);
	foreach $dirname (@tab) {
#		print "-$dirname-\n";

		if (($dirname ne '') and (!(-e $dirname))) {
			mkdir $dirname,0755;
			print "$dirname cre<BR>\n";
		}# else {
		#	$dirname=$LocalPath;
		#}
		chdir $dirname;
	}

#	print "-".`pwd`."-\n";

	# Get the file from the ftp server
	$ftp->get($name) or
		warn "Could not get '$name', skipped: $!";
	chdir $LocalPath;
}

# Close the connection to the ftp server

$ftp->quit or
	return ($log,"Could not close the connection cleanly: $!");

# We are done !
return ($log,"");
}

1;
